/*
        
@memo     
@name DatabaseGenerator_Check
@author .. , .. 
@version 1.0
@see DatabaseConfig Database
*/


#include "dbgen.h"		/*  */
#include "errcode.h"	/*   */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

/*
@memo  
*/
#define NODES_IN_CLUSTER	(FRAGMENTS_IN_RELATION)

int main(void)
{
	int node, i, j, cnt, res;
	dictionary_t * D;
	tuple_t tuple;
	FILE * f;

	printf("Test Database Generator: START\n");

	for (node=0; node<NODES_IN_CLUSTER; node++) {
		printf("\tCheck for node #%d: START\n", node);

		printf("\t\tCreate database and dictionary: START\n");
		res=db_InitDatabase(node, NULL);
		assert(res==SUCCESS);
		printf("\t\tCreate database and dictionary: STOP\n");
		
		printf("\t\tCheck database dictionary: START\n");
		D=db_DatabaseDictionary();
		assert(D!=NULL);
		assert(D->whoami==node);
		for (i=0; i<RELATIONS_IN_DATABASE; i++) {
			assert(D->relations[i].relation==i);
			assert(D->relations[i].fragment==node);
			assert(strcmp(D->relations[i].filename, RELATIONS_FILENAMES[i][node])==0);
			assert(D->relations[i].tuples==TUPLES_IN_FRAGMENT[i]);
			assert(D->relations[i].fragmentattr==FRAGMENTATION_ATTRIBUTES[i]);
			assert(D->relations[i].fragmentfn==db_FragmentByDefault);
		}
		printf("\t\tCheck database dictionary: STOP\n");

		printf("\t\tCheck fragments of relations: START\n");
		tuple=(tuple_t) calloc (ATTRIBUTES_IN_RELATION, sizeof(domain_t));
		assert(tuple!=NULL);
		for (i=0; i<RELATIONS_IN_DATABASE; i++) {
			printf("\t\t\tCheck fragment #%d (file %s): START\n", i, D->relations[i].filename);
			f=fopen(D->relations[i].filename, "rt");
			assert(f!=NULL);
			cnt=0;
			while (!feof(f)) {
				for (j=0; j<ATTRIBUTES_IN_RELATION; j++) 
					fscanf(f, "%d\t", &tuple[j]);
				fscanf(f, "\n");
				/*
				for (j=0; j<ATTRIBUTES_IN_RELATION; j++) 
					printf("%d\t", tuple[j]);
				printf("\n");
				*/
				/*
				assert(tuple[0]==cnt+(D->whoami)*(D->relations[i].tuples));
				*/
				assert(D->relations[i].fragmentfn(tuple, D->relations[i].fragmentattr)==D->whoami);
				cnt++;
			}
			assert(cnt==D->relations[i].tuples);
			fclose(f);
			printf("\t\t\tCheck fragment #%d (file %s): STOP\n", i, D->relations[i].filename);
		}
		free(tuple);
		printf("\t\tCheck fragments of relations: STOP\n");

		printf("\tCheck for node #%d: STOP\n", node);
	}
	printf("Test of Database Generator: STOP\n");

	return 0;
}