#ifndef _DBGEN_H
#define _DBGEN_H

/**
      .
@memo   
@name DatabaseGenerator
@author (c) 2004 .. , .. 
@version 1.0  \today
@see Compiler
*/

#include "dbconfig.h"	/*    */

/*@{*/

/**
       
@name DatabaseGenerator_Constants
@memo    
*/

/*@{*/

/*
@memo   
*/
#define NULL_VALUE	(-1)


/**
    0 () -EOF   \Ref{EOFmarker}.
@memo  -EOF
@see IsEOF EOFtuple
*/
#define EOFmarker	(-1)

/*@}*/

/**
       
@name DatabaseGenerator_Types
@memo    
*/

/*@{*/

/**
         int,
     (   
-EOF,       ).
@memo 
@see tuple_t ATTRIBUTES_IN_RELATION EOFtuple
*/
typedef int domain_t;

/**
        
  \Ref{ATTRIBUTES_IN_RELATION}    \Ref{domain_t}. 
      
   \Ref{ATTRIBUTES_IN_RELATION} :
\begin{verbatim}
(__1+__2)-1
\end{verbatim}
@memo 
@see domain_t ATTRIBUTES_IN_RELATION
*/
typedef domain_t* tuple_t;


typedef int (* _fragment_fn_t)(tuple_t, int);

/**
  :
\begin{verbatim}
typedef int (* _fragment_fn_t)(tuple_t, int);
\end{verbatim}
     :

\begin{tabular}{lll}
{\bf N / }	& {\bf 	} & {\bf  } \\
1		& \Ref{tuple_t}	&    \\
2		& int		&       1  \Ref{ATTRIBUTES_IN_RELATION}-1 
\end{tabular}

    0        .
      int --    (..  
 ,      )    0  
\Ref{FRAGMENTS_IN_RELATION}-1 .
@memo    
@see FRAGMENTS_IN_RELATION define_FRAGMENTATION_ATTRIBUTES domain_t db_FragmentByDefault
*/
typedef _fragment_fn_t fragment_fn_t;

struct _fragment {
	int relation;
	int fragment;
	char filename[12];
	int ary;
	int tuples;
	int fragmentattr;
	fragment_fn_t fragmentfn;
};

/**
         :

\begin{tabular}{lll}
{\bf N /}	& {\bf      }	& {\bf  } \\
1		& int relation		&    (   0  \Ref{RELATIONS_IN_DATABASE}-1 ),      \\
2		& int fragment		&    (   0  \Ref{FRAGMENTS_IN_RELATION}-1 ) \\
3		& char filename[12]	&  ,      \\
4		& int ary			&  ( )  \\
5		& int tuples		&     \\
6		& int fragmentattr	&    (   1  \Ref{ATTRIBUTES_IN_RELATION}-1 ),       0         \\
7		& \Ref{fragment_fn_t} fragmentfn &     
\end{tabular}
@memo 
@see RELATIONS_IN_DATABASE FRAGMENTS_IN_RELATION ATTRIBUTES_IN_RELATION define_FRAGMENTATION_ATTRIBUTES dictionary_t
*/
typedef struct _fragment fragment_t;

struct _dictionary {
	int whoami;	
	fragment_t relations[RELATIONS_IN_DATABASE];
};

/**
             
   ,    .    :

\begin{tabular}{lll}
{\bf N / }	& {\bf      }	& {\bf  } \\
1		& int whoami				&      \\
2		& \Ref{fragment_t} relations[\Ref{RELATIONS_IN_DATABASE}] &      
\end{tabular}
@memo  
@see RELATIONS_IN_DATABASE fragment_t
*/
typedef struct _dictionary dictionary_t;

/*@}*/

/**
-EOF    ({\bf  NULL-!})  ,  
      ,     
 .
@memo -EOF
@see IsEOF EOFmarker fm_NextTuple
*/
extern tuple_t EOFtuple;


/**
       
@name DatabaseGenerator_Functions
@memo    
*/

/*@{*/

/**
   ,    
 -EOF,      (  ,  {\bf ==NULL}).
 " "   ,     .
    -EOF,        
 \Ref{domain_t}  \Ref{EOFmarker}.
@memo    EOF
@param tuple   
@return 1    -EOF,  0
@see fm_NextTuple tuple_t domain_t EOFmarker
*/
extern int IsEOF(tuple_t tuple);

/**
             
  .
@memo   
@param node    
@param fragmentfn    .    NULL,    
	     .
@return 0       
@see db_FragmentByDefault dictionary_t DatabaseConfig ErrorCodes
*/
extern int db_InitDatabase(int node, fragment_fn_t fragmentfn);

/**
@memo      
@return         NULL   
@see dictionary_t 
*/
extern dictionary_t * db_DatabaseDictionary(void);

/**
        .
   :
\begin{verbatim}
return tuple[fragmentattr]/FRAGMENTS_IN_RELATION;
\end{verbatim}
  , :
\begin{verbatim}
return tuple[fragmentattr]/(DOMAIN_VALUE_MAX/FRAGMENTS_IN_RELATION);
\end{verbatim}
@memo   
@param tuple   
@param fragmentattr      (  0)
@return   (..    ,   
  ,     ) 
   0  \Ref{FRAGMENTS_IN_RELATION}-1 
@see db_InitDatabase fragment_fn_t domain_t define_FRAGMENTATION_ATTRIBUTES FRAGMENTS_IN_RELATION DOMAIN_VALUE_MAX
*/
extern int db_FragmentByDefault(tuple_t tuple, int fragmentattr);

/*@}*/

/*@}*/

#endif /* _DBGEN_H */