#ifndef _MSGMGR_H
#define _MSGMGR_H

/**
    .
          .
        .
      :    
   /    ,   
/   .     
(  ).

.
       ,  
 MPI (    , , \URL[]{http://www.mpi-forum.org/}).
       MPICH [\URL{http://www-unix.mcs.anl.gov/mpi/mpich/}],
  \URL[Argonne National Laboratory]{http://www.mcs.anl.gov/}.
@memo  
@name MessageManager
@author (c) 2004 .. , .. 
@version 1.0  \today
@see Parallelizer
*/

#include "dbconfig.h"	/*     */

/*@{*/

/**
     
@name MessageManager_Constants
@memo   
*/

/*@{*/

/**
       
      .
@memo    
*/
#define NODES_IN_CLUSTER	(FRAGMENTS_IN_RELATION)

/*@}*/

/**
     
@name MessageManager_Types
@memo   
*/

/*@{*/

/**
  ( )     .
        
\Ref{mm_RunRecv} (     \Ref{mm_RunSend}). 
          
  \Ref{mm_IsDone} 
@memo    
@see mm_IsDone mm_RunSend mm_RunRecv
*/
typedef int mid_t;

/*@}*/

/**
     
@name MessageManager_Functions
@memo   
*/

/*@{*/

/**
    .
           .
          mm_WhoAmI.
      .
@memo   
@return 0       
@see mm_DoneMessageManager mm_WhoAmI mm_RunSend mm_RunRecv ErrorCodes
*/
extern int mm_InitMessageManager(void);

/**
@memo    
@return       >=0    
@see mm_InitMessageManager ErrorCodes
*/
extern int mm_WhoAmI(void);

/**
          .
     (..  ).
      :    
   /     ,   
/   .     
( ).
@memo   
@param destnode  -
@param buffer    
@param len    
@return   >=0       
@see ErrorCodes mm_RunRecv mm_IsDone ErrorCodes
*/
extern mid_t mm_RunSend(int port, int destnode, void * buffer, int len);

/**
           .
      (..   ).
      :    
   /     ,   
/   .     
( ).
@memo   
@param srcnode  -
@param buffer    
@param len    
@return   >=0       
@see ErrorCodes mm_RunSend mm_IsDone ErrorCodes
*/
extern mid_t mm_RunRecv(int port, int srcnode, void * buffer, int len);

/**
         . 
           ,  
  \Ref{mm_IsDone}(__)     .
@memo   
@param operation  
@return  (==1),   ;   (==0),    ; 
    (   ) 
@see mm_RunSend mm_RunRecv ErrorCodes
*/
extern int mm_IsDone(mid_t operation);


/**
     , ..       
  ,        .
@memo  
@return 0       
@see mm_InitMessageManager mm_DoneMessageManager
*/
extern int mm_Synchronize(void);

/**
        ; 
    (     )  .

   mm_DoneMessageManager     {\Ref ENOINIT}, ..
    {\Ref mm_InitMessageManager}.
@memo   
@return 0       
@see mm_InitMessageManager ErrorCodes
*/
extern int mm_DoneMessageManager(void);

/*@}*/

/*@}*/

#endif /* _MSGMGR_H */