/*
  
@memo 
@name Debugger_Implementation
@author .. , .. 
@version 1.0
*/

#include "debug.h"	/*  */
#include "msgmgr.h"	/*   */
#include "common.h"	/*     */
#include <stdio.h>

/*@{*/

/*
    
@memo   
@name Debugger_Implementation_Variables
*/

/*@{*/

/*
@memo  
*/
static int initflag=FALSE;

/*
@memo   
*/
static int whoami;

/*
@memo  
*/
static int SCALE[NODES_IN_CLUSTER];

/*
@memo   
*/
static unsigned long dbgcnt;

/*@}*/

/*
   
@memo  
@name Debugger_Implementation_Functions
*/

/*@{*/

/*
@memo  
@param node   
*/
void dbg_Init(int node)
{
	int i;

	if (initflag)
		return;
	initflag=TRUE;
	whoami=node;
	dbgcnt=0;
	for (i=0; i<NODES_IN_CLUSTER; i++)
		SCALE[i]=FALSE;
}


int dbg_IsVisible(int node)
{
	return (node>=0 && node<NODES_IN_CLUSTER ? SCALE[node] : FALSE);
}

/*
@memo    
@param node  
*/
void dbg_Visible(int node)
{
	if (node>=0 && node<NODES_IN_CLUSTER)
		SCALE[node]=TRUE;
}

/*
@memo       
@param node  
*/
void dbg_VisibleAll(void)
{
	int i;

	for (i=0; i<NODES_IN_CLUSTER; i++)
		SCALE[i]=TRUE;
}

/*
@memo    
@param node  
*/
void dbg_Invisible(int node)
{
	if (node>=0 && node<NODES_IN_CLUSTER)
		SCALE[node]=FALSE;
}

/*
@memo       
@param node  
*/
void dbg_InvisibleAll(void)
{
	int i;

	for (i=0; i<NODES_IN_CLUSTER; i++)
		SCALE[i]=FALSE;
}

/*
@memo    
*/
int dbg_WhoAmI()
{
	return whoami;
}

/*
   1,     !
@memo    
*/
unsigned long dbg_GetDbgCnt()
{
	return ++dbgcnt;
}

/*
@memo  
@param tuple   
@param ary  
*/
void dbg_PrintTuple(tuple_t tuple, int ary)
{
	int i;

	for (i=0; i<ary; i++)
		printf("%d\t", tuple[i]);
	printf("\n");
}

/*@}*/

/*@}*/
