/*
      ()  
 .
@memo  
@name  Engine_Implementation
@author .. , .. 
@version 1.0
@see AgentManager Bracket
*/

#include "engine.h"		/*  */
#include "bracket.h"	/*   */
#include "errcode.h"	/*   */
#include "common.h"		/*     */
#include "dbgen.h"		/*    */
#include "debug.h"		/*    */
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>

/*@{*/

/*
     
@name Engine_Implementation_Variables
@memo    
@see Engine_Implementation_Functions 
*/

/*@{*/

/*
@memo  
*/
static dictionary_t * DICTIONARY;

/*
@memo   
*/
static int initflag=FALSE;

/*@}*/

/*
     
@name Engine_Implementation_Functions
@memo    
@see Engine_Implementation_Variables
*/

/*@{*/

/*
       
         .
       .
@memo   
@param node	   	
@return SUCCESS       
@see en_ExecuteQuery
*/
int en_InitEngine(int node)
{
	int res;

	DBG_INIT(node);
	START("en_InitEngine");
	if (initflag)
		return SUCCESS;
	if (node<0 || node>=FRAGMENTS_IN_RELATION)
		return EINVAL;
	if ((DICTIONARY=db_DatabaseDictionary())==NULL)
		return EINVAL;
	if (node!=DICTIONARY->whoami)
		return EINVAL;
	initflag=TRUE;
	res=br_Init(node);
	assert(res==SUCCESS);
	STOP("en_InitEngine");
	return SUCCESS;
}

/*
     .
@memo  
@return     
@see querytree_t
*/
int en_ExecuteQuery(treenode_t * root)
{
	START("en_ExecuteQuery");
	if (!initflag)
		return ENOINIT;
	if (root==NULL)
		return EINVAL;
	br_Reset(root);
	br_Next(root);
	STOP("en_ExecuteQuery");
	return SUCCESS;
}

/*@}*/

/*@}*/

